unit fs02iop_00_lib;

interface

Uses
  SysUtils;

Type
  EMyError = class(Exception); //raise EMyError.create('    -  . ');

Var
  MainDir:string;


// 
function MnemoCode_Normalize(sMnemo:string):string;
//     -   ()
function Replace_CharsInString(Sx : String;
                               CharsForRepl:String;
                               StrRepl:String=' ';
                               YesIn:boolean=true) : String;
//   
function ReplaceSymbol(str: string; oldsym, newsym: string): String;
//   SQL- (   Infocomm.exe)
function PrepareForSQL(Str: String): String;
//  ()    (2  )
function String_ExcessChar_Delete(Sx : String; Ch:char) : String;
//     (2  )
function String_ExcessSpace_Delete(Sx : String) : String;
// String  BOOLEAN
function spStrToBool(Sx: String; Def: boolean=false) : boolean;
//   IfThen (StrUTILS)
function IfThen(V:boolean;sTrue:string='true';sFalse:string='false'):string;

//    Sx   NumWord. UnChar -  
function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
// -    Sx. UnChar -  
function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
//
function RoundTo(V:extended;iRoundTo:integer=2):extended;


implementation

function MnemoCode_Normalize(sMnemo:string):string;
// 
begin
  Result:='';
  sMnemo:=trim(sMnemo);
  if sMnemo<>'' then begin
     Result := ReplaceSymbol(sMnemo, #9, #32);
     Result := ReplaceSymbol(Result, #39, #32);
     Result := ReplaceSymbol(Result, '"', #32);
     Result := ReplaceSymbol(Result, '`', #32);
     Result:=trim(String_ExcessSpace_Delete(Result));
     Result:=trim(Replace_CharsInString(Result,
                                        //#32+#39+'~`"!@#$%^&*+={}[]\|/?><.,',
                                        #32+'~!@#$%^&*+={}[]\|/?><.,',
                                        '_',
                                        true));
     Result := ReplaceSymbol(Result, '', 'N');
     Result := ReplaceSymbol(Result, '', '');
     Result := ReplaceSymbol(Result, '', '');
     Result := trim(Result);
  end;
end;

function Replace_CharsInString(Sx : String;
                               CharsForRepl:String;
                               StrRepl:String=' ';
                               YesIn:boolean=true) : String;
//     -   ()
Var
  i : integer;
begin
  Result:='';
  if (length(Sx)>0) and (length(CharsForRepl)>0) and (length(StrRepl)>0) then begin
     for i:=1 to length(Sx) do
      begin
        if POS((Sx[i]),CharsForRepl)>0 then begin
           if YesIn then begin
              Result:=Result+StrRepl; //
           end
           else begin
              Result:=Result+Sx[i];
           end;
        end
        else begin
           if YesIn then begin
              Result:=Result+Sx[i];
           end
           else begin
              Result:=Result+StrRepl; //
           end;
        end;
     end;
  end;
end;

function String_ExcessChar_Delete(Sx : String; Ch:char) : String;
//  ()    (2  )
Var
  N: integer;
begin
  Result:=trim(Sx);
  N:=1;
  while N>0 do
   begin
    N:=POS(Ch+Ch, Result);
    if N>0 then begin
       Result:=trim(ReplaceSymbol(Result, Ch+Ch, Ch));
    end;
  end;
end;
function String_ExcessSpace_Delete(Sx : String) : String;
//     (2  )
begin
  Result:=trim(String_ExcessChar_Delete(Sx, #32));
end;

function PrepareForSQL(Str: String): String;
//   SQL- (   Infocomm.exe)
begin
  Result := ReplaceSymbol(Str, '''', '''''');
end;
function ReplaceSymbol(str: string; oldsym, newsym: string): String;
//   
var i, j: integer;
  repstr, R: string;
  s1, s2: String;
begin
  s1 := oldsym;
  s2 := Str;
  i := pos(s1, s2);
  if i > 0 then begin
    R := '';
    RepStr := Str;
    while i > 0 do begin
      R := R + copy(Repstr, 1, i - 1) + newsym;
      repstr := copy(repstr, i + length(oldsym), length(Repstr));
      i := pos(oldsym, Repstr);
    end;
    Result := R + RepStr;
  end else
    Result := Str;
end;


function spStrToBool(Sx: String; Def: boolean=false) : boolean;
// String  BOOLEAN
begin
 Result:=FALSE;
 Sx:=Trim(Sx);
 if Length(Sx)>0 then begin
    Sx:=AnsiUpperCase(Sx);
    if Sx='Y'    then Result:=TRUE;
    if Sx='YES'  then Result:=TRUE;
    if Sx='YE'   then Result:=TRUE;
    if Sx=''    then Result:=TRUE;
    if Sx=''   then Result:=TRUE;
    if Sx='TRUE' then Result:=TRUE;
    if Sx='T' then Result:=TRUE;
    if Sx='' then Result:=TRUE;
    //if Sx='1' then Result:=TRUE;
    if not Result then begin
       if StrToIntDef(Trim(Sx),0)>0 then Result:=true;
    end;
 end
 else begin
    Result:=Def;
 end;
end;


function Get_Word_From_String(Sx : String; NumWord : integer; UnChar: String=' '; YesAllTrim_Before: boolean=true) : String;
//    Sx   NumWord. UnChar -  
//YesAllTrim_Before -  TRUE,          
Var
  InWord    : byte;
  NumWordCur, i : integer;
begin
  Result:='';
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     if NumWord>0 then begin
        InWord := 0;
        NumWordCur:=0;
        i:=0;
        while i<length(Sx) do
         begin
          i:=i+1;
          if POS(Sx[i],UnChar)<=0 then begin //  -  
             if InWord<=0 then NumWordCur:=NumWordCur+1; // -   
             InWord:=1; //  
             if NumWordCur=NumWord then begin // -  
                Result:=Result+Sx[i];   //     
             end;
          end
          else begin  //  - 
             InWord:=0; //  
             if NumWordCur=NumWord then begin //  -  
                i:=length(Sx)+1; //,     
             end;
          end;
        end;
     end;
  end;
end;

function Get_CountWords_In_String(Sx : String; UnChar: String=' '; YesAllTrim_Before: boolean=true) : integer;
// -    Sx. UnChar -  
var
  InWord : byte;
  i : integer;
begin
  Result:=0;
  if YesAllTrim_Before then Sx:=trim(Sx);
  if length(Sx)>0 then begin
     InWord := 0;
     i:=0;
     while i<length(Sx) do
      begin
       i:=i+1;
       if POS(Sx[i],UnChar)<=0 then begin //  -  
          if InWord<=0 then Result:=Result+1; //   
          InWord:=1; //  
       end
       else begin //  - 
          InWord:=0; //  
       end;
     end;
  end;
end;

function IfThen(V:boolean;sTrue:string='true';sFalse:string='false'):string;
//   IfThen (StrUTILS)
begin
  sTrue:=trim(sTrue);
  sFalse:=trim(sFalse);
  if length(sTrue)<=0 then sTrue:='true';
  if length(sFalse)<=0 then sFalse:='false';
  if V then begin
     Result:=sTrue;
  end
  else begin
     Result:=sFalse;
  end;
end;


function iPower_10(N:integer):int64;
//  RoundTo
// 10   N (   )
Var
  i:integer;
begin
  Result:=0;
  if n>0 then begin
     Result:=1;
     for i:=1 to N do
      begin
        Result:=Result*10;
     end;
  end;
end;

function RoundTo(V:extended;iRoundTo:integer=2):extended;
//
Var
  Sx:string;
  N,iRes : int64;
begin
  Result:=V;
  if iRoundTo>0 then begin
     N:=iPower_10(iRoundTo);
     if N>0 then begin
        iRes:=round(Result*N);
        Result:=iRes/N;
     end;
  end
  else begin
     Result:=round(V);
  end;
end;


end.


